Device Resource
Description
This resource is for managing a single device.
GET /devices/:ID
Get information on the selected device.
GET Parameters
| Name | Required | Type | Description | Default Value |
|---|---|---|---|---|
| :ID | Yes | URL Parameter | The unique ID of the device. |
GET Response Values
| Name | Type | Description |
|---|---|---|
| device_class | JSON String | The class of the device. Currently this will always be "cpe". |
| address | JSON String | The address of the device. Normally this will either be the IP address or the hostname used for the device. |
| host_hex_fingerprint | JSON String | The host hex fingerprint. Typically this is set to "ignore". |
| name | JSON String | The display name of the device in rWeb. |
| username | JSON String | The username used for connecting to the device. Default is "admin". |
| connection_status | JSON String | The current status of rWeb's connection to the device. This is "connected" when the device is reachable, and becomes "no route to host" when the device is unreachable. When a device is unreachable, many other device values listed here will revert to "false", since its current status is not known. Any scripts relying on knowing device functionality should only trust responses while the device is in the "connected" state. |
| supports_tcp_dump | JSON Boolean | Whether the device supports tcpdump. |
| jumbo_frame_support_level | JSON String | This will be "rw" if jumbo frames can be enabled, "ro" if the device has the capability but it isn't supported, and "none" if there is no jumbo frame functionality. |
| device_resource | JSON String | The unique device resource for this device. |
| device_status_resource | JSON String | The device status resource for this device. |
| device_configurations_resource | JSON String | The device configurations resource for this device. |
| device_local_configurations_resource | JSON String | The device local configurations resource for this device. |
| device_values_resource | JSON String | The device values resource for this device. |
| command_resource | JSON String | The command resource for this device. |
| load_resource | JSON String | The load resource for this device. |
| upgrade_resource | JSON String | The upgrade resource for this device. |
| change_password_resource | JSON String | The change password resource for this device. |
| reboot_resource | JSON String | The reboot resource for this device. |
| log_resource | JSON String | The log resource for this device. |
| device_zones_resource | JSON String | The device zones resource for this device. |
| device_port_traffic_resource | JSON String | The device port traffic resource for this device. |
| supports_ddos_command | JSON Boolean | Whether the device supports internal DDoS commands. Primarily used for updated filter list functionality. |
| usage_resource | JSON String | The usage resource for this device. |
| password | JSON String | The password rWeb will use when attempting to connect to the device. |
| tcp_dumps_resource | JSON String | The tcp dumps resource for this device. |
| switchover_resource | JSON String | The switchover resource for this device. |
| patch_panel_resource | JSON String | The patch panel resource for this device. |
| tunnels_supported | JSON Boolean | Whether this device supports tunnels. |
| tunnels_resource | JSON String | The tunnels resource for this device. |
| snmp_supported | JSON String | Whether this device supports SNMP. |
| snmp_v1v2_resource | JSON String | The resource for configuring SNMP v1 and v2 for this device. |
| snmp_v3_usm_resource | JSON String | The resource for configuring SNMP v3 for this device. |
| license_supported | JSON Boolean | Whether this device supports licensing. Functionally this will always be "true" and could only be "false" for extremely old versions of RIOS. |
| license_resource | JSON String | The license resource for this device. |
| support_upload_supported | JSON Boolean | Whether this device can generate support uploads. |
| support_upload_resource | JSON String | The support upload resource for this device. |
| request_support_resource | JSON String | The request support upload resource for this device. |
| support_dump_by_zoneid | JSON Boolean | Whether the device supports tcpdump across an entire zone. If "false", the device will require destination addresses to be specified for captures. |
| supports_filter_mode_off | JSON Boolean | Whether the device can set filter mode for algorithms to "off". Functionally this will always be "true" and could only be "false" for extremely old versions of RIOS. |
Example GET Request
GET /devices/515
Example GET Response
{
"device_class": "cpe",
"address": "rs30-3",
"host_hex_fingerprint": "ignore",
"name": "rs30-3",
"username": "admin",
"connection_status": "connected",
"supports_tcp_dump": true,
"jumbo_frame_support_level": "rw",
"device_resource": "/devices/515",
"device_status_resource": "/devices/515/status",
"device_configurations_resource": "/devices/515/configurations",
"device_local_configurations_resource": "/devices/515/local_configurations",
"device_values_resource": "/devices/515/values",
"command_resource": "/devices/515/current_command",
"load_resource": "/devices/515/load",
"upgrade_resource": "/devices/515/upgrade",
"downgrade_resource": "/devices/515/downgrade",
"change_password_resource": "/devices/515/change_password",
"reboot_resource": "/devices/515/reboot",
"log_resource": "/devices/515/logs",
"device_zones_resource": "/devices/515/zones",
"device_port_traffic_resource": "/devices/515/port_traffic",
"supports_ddos_command": true,
"usage_resource": "/devices/515/resource_usage",
"tcp_dumps_resource": "/devices/515/tcp_dump",
"switchover_resource": "/devices/515/switchover",
"tunnels_supported": true,
"tunnels_resource": "/devices/515/tunnels",
"snmp_supported": true,
"snmp_v1v2_resource": "/devices/515/snmp_v1v2",
"snmp_v3_usm_resource": "/devices/515/snmp_v3_usm",
"license_supported": true,
"license_resource": "/devices/515/licenses",
"support_upload_supported": true,
"support_upload_resource": "/devices/515/support_upload",
"request_support_resource": "/devices/515/request_support",
"support_dump_by_zoneid": true,
"supports_filter_mode_off": true
}
PUT /devices/:ID
Update a single device.
PUT Parameters
| Name | Required | Type | Description | Default Value |
|---|---|---|---|---|
| :ID | Yes | URL Parameter | The unique ID of the device to up | |
| address | No | JSON String | The IP address or hostname for the new device. | |
| name | No | JSON String | The display name for the device in rWeb. | |
| device_class | No | JSON String | This should be "CPE". | |
| username | No | JSON String | This should be "admin". | |
| password | No | JSON String | This will be the connection password. It may change depending on how you did the device installation, and whether or not you changed the password previously. | |
| host_hex_fingerprint | No | JSON String | This should be "ignore". |
Example PUT Request
PUT /devices/515
JSON Body:
{
"data": {
"address":"rs30-3",
"name":"rs30-3",
"device_class":"CPE",
"username":"admin",
"password":"admin123",
"host_hex_fingerprint":"ignore"
}
}
Example PUT Response
HTTP/1.1 200 OK
DELETE /devices/:ID
This will remove the device from rWeb.
DELETE Parameters
| Name | Required | Type | Description | Default Value |
|---|---|---|---|---|
| :ID | Yes | URL Parameter | The unique ID of the device to remove. |
Example DELETE Request
DELETE /devices/515
Example DELETE Response
HTTP/1.1 200 OK